#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#include <math.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <map>
#include <utility>

#include <assert.h>

using namespace std;

#define TOL 1.E-12
#define LINE_LENGTH 256

template <class T>
ostream& operator << (ostream& out, const vector<T> &v) {
	out << "{";
	typename vector<T>::const_iterator itr;
	for (itr = v.begin(); itr != v.end()-1; itr++) {
		out << *itr << ",";
	}
	out << *itr << "}";
	return out;
}

template <class T>
typename vector<T>::iterator replace(vector<T> &v, typename vector<T>::iterator itr, const T &value) {
	itr = v.erase(itr);
	return v.insert(itr, value);
}

class Functions {
public:
	Functions();
	
	static double Compare(double LHS, double RHS, double epsilon = TOL);
	static double Max(double LHS, double RHS);

	static double CubeRoot(double value);
	static double Pow(double value, double power);

	static void Debug(const char* fmt, ...);
	
	static bool equal(double u, double v, double epsilon = TOL);

        static double Grycuk(double b_i, double b_j, double r_ij);

	static double SmoothFactor(double R_sphere, double r_ij); 

	//static double D_0(double R_1, double R_2, double R_w);
	//static double M_0(double R_1, double R_2, double R_w);

	//static bool loadD_0(string fileName);
	//static bool loadM_0(string fileName);
	
private:
	//static map<string, double> d_0;
	//static map<string, double> m_0;
};

//map<string, double> Functions::d_0;
//map<string, double> Functions::m_0;

#endif
