///////////////////////////////////////////////
//Modified by Boris Aguilar (BA) Aug 4 2009
////////////////////////

#ifndef NECK_PARAMS_H
#define NECK_PARAMS_H

#include <string>
#include <fstream>

#include "Functions.h"
#include "Atom.h"
#include "Molecule.h"
#include "MolecularIntegration.h"

using namespace std;

struct Node {
  double Ri, Rj;
  double Aij;
  double Bij; // Second Parameter of our Neck function B.A
  Node *next;
};

class NeckParams {
public:
  NeckParams();
  void loadFromFile(string f);
  Node* lookup(double Ri, double Rj);
  ~NeckParams();
  
  double WaterRadius() const; // Get water radius from necks B.A
  void WaterRadius(double paramRw); // introduce water radius for Necks B.A

  //NumbAtoms = 41 ; //The number of possible different types of Radius

private:
  bool flush(string f);
  bool dirty;
  void findNeckParam(double Ri, double Rj, Node* n);
  void findNeckParam2(double Ri, double Rj, Node* n);
  void findNeckParam3(double Ri, double Rj, Node* n);
  double findA(double value, double distance, double Ri, double Rj);
  int hash(double Ri, double Rj);
  Node* findNode(int index, double Ri, double Rj);

  string fileName;
  Node* table;
  double r_w; //Water radius used just for necks B.A
};

#endif
