#ifndef VDW_INTEGRATION_H
#define VDW_INTEGRATION_H

#include "Molecule.h"

class VDWIntegration {
public:
	static void calcIntegralR4(Molecule &m, int depth);
	static void calcIntegralR6(Molecule &m, int depth);

	static double integrateBlockR4(Molecule &m, double xMin, double yMin, double zMin,
 	 double size, int step, int maxSteps, Atom &a_i);
	static double integrateBlockR6(Molecule &m, double xMin, double yMin, double zMin,
 	 double size, int step, int maxSteps, Atom &a_i);

	static void calcIntegralR6Spherical(Molecule &m, double stepSize);
	static double volume(Molecule &m, int depth);
	static double integrateBlockVolume(Molecule &m, double xMin, double yMin, double zMin,
 	 double size, int step, int maxSteps);
};

#endif
